unit CreatDBF;
interface
uses DAE, DBFTable, Views, Objects, Clases, Ext_Type, Drivers, Dialogs;

type
   Form2Record=record
      InputLine1:string[10];
      RangeILine1:Longint;
      RangeILine2:Longint;
      RadioButtons1:word;
   end;

type
   NewTableRecord=record
      ListBox:TListBoxRec;
      BDType:Longint;
   end;

procedure CreateDataBase(var TableName:FNameStr);
procedure CreateTableDialog_HandleEvent(Sender: PView; var Event: TEvent;
                           EventTime:TEventTime);far;
implementation
uses ResTools, s_DBView, Ext_Str, Ext_Math, cmdbview, DAE_Type, Register;

  { TCreateTableDialog }

procedure CreateTableDialog_HandleEvent(Sender: PView; var Event: TEvent;
                           EventTime:TEventTime);
var
  ListBox:PListBox absolute Sender;
procedure Update;
begin
  ListBox^.SetRange(ListBox^.List^.Count);
  ListBox^.DrawView;
end;

procedure FAdd;
var Rec:Form2Record;
    S,S1:string;
begin
  FillChar(Rec, SizeOf(Form2Record), 0);
  if RExecDialog(sNewDBFieldDialog, @Rec)<>cmCancel then
  begin
    S:=FillSpaceA(Rec.InputLine1,11)+'|';
    S1:='CNDLxM';
    S:=S+' '+S1[Rec.RadioButtons1+1]+' |  ';
    Str(Rec.RangeILine1:3,S1);
    S:=S+S1+' | ';
    Str(Rec.RangeILine2:2,S1);
    S:=S+S1;
    ListBox^.List^.Insert(NewStr(S));
  end;
end;

procedure FDel;
begin
  if ListBox^.List^.Count=0 then exit;
  ListBox^.List^.AtFree(ListBox^.Focused);
end;

procedure FEdit;
var Rec:Form2Record;
    S,S1:string;
begin
  if ListBox^.List^.Count=0 then exit;
  S:=PString(ListBox^.List^.At(ListBox^.Focused))^;
  case S[14] of
    'C':Rec.RadioButtons1:=0;
    'N':Rec.RadioButtons1:=1;
    'D':Rec.RadioButtons1:=2;
    'L':Rec.RadioButtons1:=3;
    'M':Rec.RadioButtons1:=5;
  end;
  Rec.InputLine1:=Trim(Copy(S,1,10));
  Rec.RangeILine1:=StrToInt(Trim(Copy(S,19,3)));
  Rec.RangeILine2:=StrToInt(Trim(Copy(S,25,2)));
  if RExecDialog(sNewDBFieldDialog, @Rec)<>cmCancel then
  begin
    S:=FillSpaceA(Rec.InputLine1,11)+'|';
    S1:='CNDLxM';
    S:=S+' '+S1[Rec.RadioButtons1+1]+' |  ';
    Str(Rec.RangeILine1:3,S1);
    S:=S+S1+' | ';
    Str(Rec.RangeILine2:2,S1);
    S:=S+S1;
    ListBox^.List^.AtFree(ListBox^.Focused);
    ListBox^.List^.AtInsert(ListBox^.Focused,NewStr(S));
  end;
end;

begin
  case Event.Command of
     cmFAdd:FAdd;
     cmFDel:FDel;
     cmFEdit:FEdit;
  else
    exit;
  end;
  Update;
end;


procedure CreateDataBase(var TableName:FNameStr);
var Rec:NewTableRecord;
    List:PStrings;
    cDBF:PDBFTableConstructor;
    P:PObject;
    TableVersion, CodePage:byte;

procedure DoAddField(P:PString);far;
var fType:TFieldType;
begin
  case P^[14] of
    'C':fType:=ftString;
    'N':fType:=ftFloat;
    'D':fType:=ftDateTime;
    'L':fType:=ftBoolean;
    'M':fType:=ftMemo;
  end;
  cDbf^.AddField(Trim(Copy(P^,1,10)),fType,StrToInt(Trim(Copy(P^,19,3))),StrToInt(Trim(Copy(P^,25,2))));
end;
begin
  List:=New(PStrings, Init);
  FillChar(Rec, SizeOf(NewTableRecord), 0);
  Rec.BDType:=1;
  Rec.ListBox.List:=List;
  if (RExecDialog(sCreateTableDialog,@Rec)<>cmCancel) and
     (List^.Count<>0) and
     (RExecDialog(sDBFCreateDialog, @TableName)<>cmCancel) then
  begin
    case Rec.BDType of
      0:TableVersion:=verDBase2;
      1:TableVersion:=verDBase3;
      2:TableVersion:=verDBase4Memo;
      3:TableVersion:=verDBase4Memo;
      4:TableVersion:=verFoxPro2XMemo;
      5:TableVersion:=verFoxPro2XMemo;
      6:TableVersion:=verDBase7;
    end;
    if Rec.BDType in [3,5] then CodePage:=dbfCP_1251
    else CodePage:=0;
    cDBF:=New(PDBFTableConstructor, Init(TableName,TableVersion, CodePage));
    List^.ForEach(@DoAddField);
    P:=cDbf^.CreateTable;
    if (P<>nil) then P^.Free
    else TableName:='';
    cDBF^.Free;
  end;
  Dispose(List, Done);
end;

end.
